module.exports = function (plop) {
    // controller generator
    plop.setGenerator('install', {
        description: 'Install scffld into root of your project',
        prompts: [{
            type: 'input',
            name: 'buildDir',
            message:
                "Hello! Welcome to: \n\n\n" +
                "███████╗ ██████╗███████╗███████╗██╗     ██████╗ \n" +
                "██╔════╝██╔════╝██╔════╝██╔════╝██║     ██╔══██╗\n" +
                "███████╗██║     █████╗  █████╗  ██║     ██║  ██║\n" +
                "╚════██║██║     ██╔══╝  ██╔══╝  ██║     ██║  ██║\n" +
                "███████║╚██████╗██║     ██║     ███████╗██████╔╝\n" +
                "╚══════╝ ╚═════╝╚═╝     ╚═╝     ╚══════╝╚═════╝ \n\n" +
                "Please specifiy your build directory or press enter for default:",
            default: 'dist'
        }, {
                type: 'list',
                name: 'cssPreprocessor',
                message: 'What CSS Preprocessor would you like to use?',
                choices: [
                    {name: 'SASS/SCSS', value: 'sass', checked: true},
                    {name: 'LESS', value: 'less'}
                ]
        }],
        actions: [{
            type: 'add',
            path: 'test.babelrc',
            templateFile: __dirname + '/.babelrc'
        },{
            type: 'add',
            path: 'test.editorconfig',
            templateFile: __dirname + '/.editorconfig'
        },{
            type: 'add',
            path: 'test.gulpfile.babel.js',
            templateFile: __dirname + '/gulpfile.babel.js'
        },
        function addConfigToPackageJson(answers) {
            var fs = require('fs');
            var pjson = require('./package.json');
            var configFilePath = __dirname + '/templates/config.json';

            if (fs.existsSync(configFilePath)) {

                var config = plop.renderString(
                    fs.readFileSync(configFilePath, "utf8"),
                    answers
                );

                pjson.scffld2 = JSON.parse(config);
                fs.writeFile('./package.json', JSON.stringify(pjson, null, 2), function (err) {
                  if (err) return console.log(err);
                });

                // console.log(config);
                return 'Added scffld config to package.json';
            } else {
                return 'Config template not found!';
            }

        }]
    });
};
